## spire 1.12.3

=== Makefile ===
DIR := ${CURDIR}

# There is no reason GOROOT should be set anymore. Unset it so it doesn't mess
# with our go toolchain detection/usage.
ifneq ($(GOROOT),)
	export GOROOT=
endif

E:=@
ifeq ($(V),1)
	E=
endif

cyan := $(shell which tput > /dev/null && tput setaf 6 2>/dev/null || echo "")
reset := $(shell which tput > /dev/null && tput sgr0 2>/dev/null || echo "")
bold  := $(shell which tput > /dev/null && tput bold 2>/dev/null || echo "")

.PHONY: default all help

default: build

all: build lint test

help:
	@echo "$(bold)Usage:$(reset) make $(cyan)<target>$(reset)"
	@echo
	@echo "$(bold)Build:$(reset)"
	@echo "  $(cyan)build$(reset)                                 - build all SPIRE binaries (default)"
	@echo
	@echo "$(bold)Test:$(reset)"
	@echo "  $(cyan)test$(reset)                                  - run unit tests"
	@echo "  $(cyan)race-test$(reset)                             - run unit tests with race detection"
	@echo "  $(cyan)integration$(reset)                           - run integration tests (requires Docker images)"
	@echo "                                          support 'SUITES' variable for executing specific tests"
	@echo "                                          and 'IGNORE_SUITES' variable for ignoring tests"
	@echo "                                          e.g. SUITES='suites/join-token suites/k8s' make integration"
	@echo "  $(cyan)integration-windows$(reset)                   - run integration tests for windows (requires Docker images)"
	@echo "                                          support 'SUITES' variable for executing specific tests"
	@echo "                                          e.g. SUITES='windows-suites/windows-workload-attestor' make integration-windows"
	@echo
	@echo "$(bold)Lint:$(reset)"
	@echo "  $(cyan)lint$(reset)                                  - lint the code and markdown files"
	@echo "  $(cyan)lint-code$(reset)                             - lint the code"
	@echo "  $(cyan)lint-md$(reset)                               - lint markdown files"
	@echo
	@echo "$(bold)Build, lint and test:$(reset)"
	@echo "  $(cyan)all$(reset)                                   - build all SPIRE binaries, run linters and unit tests"
	@echo
	@echo "$(bold)Docker image:$(reset)"
	@echo "  $(cyan)images$(reset)                                - build all SPIRE Docker images"
	@echo "  $(cyan)images-no-load$(reset)                        - build all SPIRE Docker images but don't load them into the local docker registry"
	@echo "  $(cyan)spire-server-image$(reset)                    - build SPIRE server Docker image"
	@echo "  $(cyan)spire-agent-image$(reset)                     - build SPIRE agent Docker image"
	@echo "  $(cyan)oidc-discovery-provider-image$(reset)         - build OIDC Discovery Provider Docker image"
	@echo "$(bold)Windows docker image:$(reset)"
	@echo "  $(cyan)images-windows$(reset)                        - build all SPIRE Docker images for windows"
	@echo "  $(cyan)spire-server-image-windows$(reset)            - build SPIRE server Docker image for windows"
	@echo "  $(cyan)spire-agent-image-windows$(reset)             - build SPIRE agent Docker image for windows"
	@echo "  $(cyan)oidc-discovery-provider-image-windows$(reset) - build OIDC Discovery Provider Docker image for windows"
	@echo "$(bold)Developer support:$(reset)"
	@echo "  $(cyan)dev-image$(reset)                             - build the development Docker image"
	@echo "  $(cyan)dev-shell$(reset)                             - run a shell in a development Docker container"
	@echo
	@echo "$(bold)Code generation:$(reset)"
	@echo "  $(cyan)generate$(reset)                              - generate protocol buffers and plugin interface code"
	@echo "  $(cyan)generate-check$(reset)                        - ensure generated code is up to date"
	@echo
	@echo "For verbose output set V=1"
	@echo "  for example: $(cyan)make V=1 build$(reset)"

# Used to force some rules to run every time
FORCE: ;

############################################################################
# OS/ARCH detection
############################################################################
os1=$(shell uname -s)
os2=
ifeq ($(os1),Darwin)
os1=darwin
os2=osx
else ifeq ($(os1),Linux)
os1=linux
os2=linux
else ifeq (,$(findstring MYSYS_NT-10-0-, $(os1)))
os1=windows
os2=windows
else
$(error unsupported OS: $(os1))
endif

arch1=$(shell uname -m)
ifeq ($(arch1),x86_64)
arch2=amd64
else ifeq ($(arch1),aarch64)
arch2=arm64
else ifeq ($(arch1),arm64)
arch2=arm64
else ifeq ($(arch1),s390x)
arch2=s390x
else ifeq ($(arch1),ppc64le)
arch2=ppc64le
else
$(error unsupported ARCH: $(arch1))
endif

ignore_suites := $(IGNORE_SUITES)

############################################################################
# Docker TLS detection for buildx
############################################################################
dockertls=
ifeq ($(DOCKER_TLS_VERIFY), 1)
dockertls=spire-buildx-tls
endif

############################################################################
# Vars
############################################################################

PLATFORMS ?= linux/amd64,linux/arm64

binaries := spire-server spire-agent oidc-discovery-provider

build_dir := $(DIR)/.build/$(os1)-$(arch1)

go_version := $(shell cat .go-version)
go_dir := $(build_dir)/go/$(go_version)

ifeq ($(os1),windows)
	go_bin_dir = $(go_dir)/go/bin
	go_url = https://go.dev/dl/go$(go_version).$(os1)-$(arch2).zip
	exe=".exe"
else
	go_bin_dir = $(go_dir)/bin
	go_url = https://go.dev/dl/go$(go_version).$(os1)-$(arch2).tar.gz
	exe=
endif

go_path := PATH="$(go_bin_dir):$(PATH)"

golangci_lint_version := $(shell grep "github.com/golangci/golangci-lint v" go.mod | awk '{print $$2}')
golangci_lint_dir = $(build_dir)/golangci_lint/$(golangci_lint_version)
golangci_lint_cache = $(golangci_lint_dir)/cache

markdown_lint_version := $(shell awk '/markdown_lint/{print $$2}' .spire-tool-versions)
markdown_lint_image = ghcr.io/igorshubovych/markdownlint-cli:$(markdown_lint_version)

protoc_version := $(shell awk '/protoc/{print $$2}' .spire-tool-versions)
ifeq ($(os1),windows)
protoc_url = https://github.com/protocolbuffers/protobuf/releases/download/v$(protoc_version)/protoc-$(protoc_version)-win64.zip
else ifeq ($(arch2),arm64)
protoc_url = https://github.com/protocolbuffers/protobuf/releases/download/v$(protoc_version)/protoc-$(protoc_version)-$(os2)-aarch_64.zip
else ifeq ($(arch2),s390x)
protoc_url = https://github.com/protocolbuffers/protobuf/releases/download/v$(protoc_version)/protoc-$(protoc_version)-$(os2)-s390_64.zip
else ifeq ($(arch2),ppc64le)
protoc_url = https://github.com/protocolbuffers/protobuf/releases/download/v$(protoc_version)/protoc-$(protoc_version)-$(os2)-ppcle_64.zip
else
protoc_url = https://github.com/protocolbuffers/protobuf/releases/download/v$(protoc_version)/protoc-$(protoc_version)-$(os2)-$(arch1).zip
endif
protoc_dir = $(build_dir)/protoc/$(protoc_version)
protoc_bin = $(protoc_dir)/bin/protoc

protoc_gen_go_version := $(shell grep google.golang.org/protobuf go.mod | awk '{print $$2}')
protoc_gen_go_base_dir := $(build_dir)/protoc-gen-go
protoc_gen_go_dir := $(protoc_gen_go_base_dir)/$(protoc_gen_go_version)-go$(go_version)
protoc_gen_go_bin := $(protoc_gen_go_dir)/protoc-gen-go

protoc_gen_go_grpc_version := v1.3.0
protoc_gen_go_grpc_base_dir := $(build_dir)/protoc-gen-go-grpc
protoc_gen_go_grpc_dir := $(protoc_gen_go_grpc_base_dir)/$(protoc_gen_go_grpc_version)-go$(go_version)
protoc_gen_go_grpc_bin := $(protoc_gen_go_grpc_dir)/protoc-gen-go-grpc

protoc_gen_go_spire_version := $(shell grep github.com/spiffe/spire-plugin-sdk go.mod | awk '{print $$2}')
protoc_gen_go_spire_base_dir := $(build_dir)/protoc-gen-go-spire
protoc_gen_go_spire_dir := $(protoc_gen_go_spire_base_dir)/$(protoc_gen_go_spire_version)-go$(go_version)
protoc_gen_go_spire_bin := $(protoc_gen_go_spire_dir)/protoc-gen-go-spire

# There may be more than one tag. Only use one that starts with 'v' followed by
# a number, e.g., v0.9.3.
git_tag := $(shell git tag --points-at HEAD | grep '^v[0-9]*')
git_hash := $(shell git rev-parse --short=7 HEAD)
git_dirty := $(shell git status -s)

protos := \
	proto/private/server/journal/journal.proto \
	proto/spire/common/common.proto \

api-protos := \

plugin-protos := \
	proto/spire/common/plugin/plugin.proto

service-protos := \

# The following vars are used in rule construction
comma := ,
null  :=
space := $(null) #

#############################################################################
# Utility functions and targets
#############################################################################

.PHONY: git-clean-check

tolower = $(shell echo $1 | tr '[:upper:]' '[:lower:]')

goenv = $(shell PATH="$(go_bin_dir):$(PATH)" go env $1)

git-clean-check:
ifneq ($(git_dirty),)
	git diff
	@echo "Git repository is dirty!"
	@false
else
	@echo "Git repository is clean."
endif

############################################################################
# Determine go flags
############################################################################

# Flags passed to all invocations of go test
go_test_flags :=
ifeq ($(NIGHTLY),)
	# Cap unit-test timout to 90s unless we're running nightlies.
	go_test_flags += -timeout=90s
endif

go_flags :=
ifneq ($(GOPARALLEL),)
	go_flags += -p=$(GOPARALLEL)
endif

ifneq ($(GOVERBOSE),)
	go_flags += -v
endif

# Determine the ldflags passed to the go linker. The git tag and hash will be
# provided to the linker unless the git status is dirty.
go_ldflags := -s -w
ifeq ($(git_dirty),)
	ifneq ($(git_tag),)
		# Remove the "v" prefix from the git_tag for use as the version number.
		# e.g. 0.9.3 instead of v0.9.3
		git_version_tag := $(git_tag:v%=%)
		go_ldflags += -X github.com/spiffe/spire/pkg/common/version.gittag=$(git_version_tag)
	endif
	ifneq ($(git_hash),)
		go_ldflags += -X github.com/spiffe/spire/pkg/common/version.githash=$(git_hash)
	endif
endif

#############################################################################
# Build Targets
#############################################################################

.PHONY: build
build: tidy $(addprefix bin/,$(binaries))

go_build := $(go_path) go build $(go_flags) -ldflags '$(go_ldflags)' -o

bin/%: cmd/% FORCE | go-check
	@echo Building $@…
	$(E)$(go_build) $@$(exe) ./$<

bin/%: support/% FORCE | go-check
	@echo Building $@…
	$(E)$(go_build) $@$(exe) ./$<

#############################################################################
# Build static binaries for docker images
#############################################################################

.PHONY: build-static
# The build-static is intended to statically link to musl libc.
# There are possibilities of unexpected errors when statically link to GLIBC.
# https://7thzero.com/blog/golang-w-sqlite3-docker-scratch-image
build-static: tidy $(addprefix bin/static/,$(binaries))

go_build_static := $(go_path) go build $(go_flags) -ldflags '$(go_ldflags) -linkmode external -extldflags "-static"' -o

bin/static/%: cmd/% FORCE | go-check
	@echo Building $@…
	$(E)$(go_build_static) $@$(exe) ./$<

bin/static/%: support/% FORCE | go-check
	$(E)$(go_build_static) $@$(exe) ./$<

#############################################################################
# Test Targets
#############################################################################

.PHONY: test race-test integration integration-windows

test: | go-check
ifneq ($(COVERPROFILE),)
	$(E)$(go_path) go test $(go_flags) $(go_test_flags) -covermode=atomic -coverprofile="$(COVERPROFILE)" ./...
else
	$(E)$(go_path) go test $(go_flags) $(go_test_flags) ./...
endif

race-test: | go-check
ifneq ($(COVERPROFILE),)
	$(E)$(go_path) go test $(go_flags) $(go_test_flags) -race -coverprofile="$(COVERPROFILE)" ./...
else
	$(E)$(go_path) go test $(go_flags) $(go_test_flags) -race ./...
endif

integration:
ifeq ($(os1), windows)
	$(error Integration tests are not supported on windows)
else

=== debian/changelog ===
spire (1.12.3-0kali1) kali-dev; urgency=medium

  * New upstream version 1.12.3

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 20 Jun 2025 11:14:58 +0200

spire (1.12.2-0kali1) kali-dev; urgency=medium

  * New upstream version 1.12.2

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 20 May 2025 12:04:10 +0200

spire (1.12.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.12.1
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 09 May 2025 15:04:30 +0200

spire (1.12.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.12.0

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 24 Mar 2025 17:44:26 +0100

spire (1.11.2-0kali1) kali-dev; urgency=medium

  * New upstream version 1.11.2

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 24 Feb 2025 18:21:34 +0100

spire (1.11.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.11.0

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 29 Oct 2024 16:23:21 +0100

spire (1.10.4-0kali1) kali-dev; urgency=medium

  * New upstream version 1.10.4

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 17 Sep 2024 11:54:37 +0200

spire (1.10.3-0kali1) kali-dev; urgency=medium

  * New upstream version 1.10.3

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 05 Sep 2024 16:37:41 +0200

spire (1.10.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.10.1

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 21 Aug 2024 10:55:15 +0200

spire (1.9.6-0kali1) kali-dev; urgency=medium

  * New upstream version 1.9.6

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 15 May 2024 17:17:56 +0200

spire (1.9.4-0kali1) kali-dev; urgency=medium

  * New upstream version 1.9.4

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 30 Apr 2024 11:49:17 +0200

spire (1.9.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.9.1
  * Remove debian/vendor

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 15 Mar 2024 12:02:21 +0100

spire (1.8.6-0kali1) kali-dev; urgency=medium

  * Disable builds on 32 bits
  * New upstream version 1.8.6
  * Refresh patches
  * Update debian/vendor

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 28 Dec 2023 14:22:18 +0100

spire (1.7.2-0kali2) kali-dev; urgency=medium

  * Add missing files sigstore/cosign/v2/internal/pkg/oci* sigstore/cosign/v2/pkg/oci*

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 20 Sep 2023 11:23:27 +0200

spire (1.7.2-0kali1) kali-dev; urgency=medium

  * Initial release.

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 14 Sep 2023 13:33:03 +0200

## spire 1.12.4

=== debian/changelog ===
spire (1.12.4-0kali1) kali-dev; urgency=medium

  * New upstream version 1.12.4

 -- Sophie Brun <sophie@kali.org>  Wed, 02 Jul 2025 11:32:18 +0200

=== debian/control ===
Source: spire
Section: utils
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               ca-certificates,
               dh-golang,
               golang-any
Standards-Version: 4.6.2
Homepage: https://github.com/spiffe/spire
Vcs-Browser: https://gitlab.com/kalilinux/packages/spire
Vcs-Git: https://gitlab.com/kalilinux/packages/spire.git
XS-Go-Import-Path: github.com/spiffe/spire

Package: spire
Architecture: amd64 arm64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: toolchain of APIs for establishing trust between software systems
 This package contains SPIRE (the SPIFFE Runtime Environment). It is a
 toolchain of APIs for establishing trust between software systems across a
 wide variety of hosting platforms. SPIRE exposes the SPIFFE Workload API,
 which can attest running software systems and issue SPIFFE IDs and SVIDs to
 them. This in turn allows two workloads to establish trust between each other,
 for example by establishing an mTLS connection or by signing and verifying a
 JWT token. SPIRE can also enable workloads to securely authenticate to a
 secret store, a database, or a cloud provider service.

## spire 1.13.0

=== debian/changelog ===
spire (1.13.0-0kali1) kali-dev; urgency=medium

  * Update my email
  * New upstream version 1.13.0
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Mon, 18 Aug 2025 15:16:51 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Kali Developers <devel@kali.org>
-Uploaders: Sophie Brun <sophie@offensive-security.com>
+Uploaders: Sophie Brun <sophie@kali.org>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                ca-certificates,

=== debian/tests/control ===
Test-Command: spire-agent --help && spire-server --help
Restrictions: superficial, allow-stderr

## spire 1.13.2

=== debian/changelog ===
spire (1.13.2-0kali1) kali-dev; urgency=medium

  * New upstream version 1.13.2

 -- Sophie Brun <sophie@kali.org>  Thu, 09 Oct 2025 15:27:07 +0200

spire (1.13.1-0kali1) kali-dev; urgency=medium

  [ Arnaud Rebillout ]
  * Drop 'Rules-Requires-Root: no' from d/control
  * Drop armel-related variable from CI (no more armel runner)

  [ Sophie Brun ]
  * New upstream version 1.13.1

 -- Sophie Brun <sophie@kali.org>  Thu, 25 Sep 2025 11:32:13 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Kali Developers <devel@kali.org>
 Uploaders: Sophie Brun <sophie@kali.org>
-Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                ca-certificates,
                dh-golang,

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export GOCACHE = $(CURDIR)/_build
export GOPATH = $(CURDIR)/_build

%:
	dh $@ --with=golang --buildsystem=golang --builddirectory=_build 

override_dh_auto_build:
	cd _build && go env
	cd _build/src/github.com/spiffe/spire/cmd/spire-agent && go build -o spire-agent .
	cd _build/src/github.com/spiffe/spire/cmd/spire-server && go build -o spire-server .

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_auto_test:

override_dh_golang:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/spiffe/spire/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

## spire 1.13.3

=== Makefile ===
--- 
+++ 
@@ -139,7 +139,7 @@
 
 go_path := PATH="$(go_bin_dir):$(PATH)"
 
-golangci_lint_version := $(shell grep "github.com/golangci/golangci-lint v" go.mod | awk '{print $$2}')
+golangci_lint_version := $(shell awk '/golangci-lint/{print $$2}' .spire-tool-versions)
 golangci_lint_dir = $(build_dir)/golangci_lint/$(golangci_lint_version)
 golangci_lint_cache = $(golangci_lint_dir)/cache

=== debian/changelog ===
spire (1.13.3-0kali1) kali-dev; urgency=medium

  * New upstream version 1.13.3

 -- Sophie Brun <sophie@kali.org>  Wed, 29 Oct 2025 18:06:45 +0100

## spire 1.14.0

=== debian/changelog ===
spire (1.14.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.14.0

 -- Sophie Brun <sophie@kali.org>  Wed, 17 Dec 2025 14:49:49 +0100

## spire 1.14.1

=== debian/changelog ===
spire (1.14.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.14.1
  * Bump Standards-Version to 4.7.3
  * update debian/watch to version 5

 -- Sophie Brun <sophie@kali.org>  Tue, 20 Jan 2026 15:50:17 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                ca-certificates,
                dh-golang,
                golang-any
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/spiffe/spire
 Vcs-Browser: https://gitlab.com/kalilinux/packages/spire
 Vcs-Git: https://gitlab.com/kalilinux/packages/spire.git

=== debian/watch ===
Version: 5
Template: Github
Dist: https://github.com/spiffe/spire
